package sun.tracing;

import java.util.Iterator;
import java.util.HashSet;
import com.sun.tracing.Provider;
import java.lang.reflect.Method;
import com.sun.tracing.Probe;
import java.util.Set;

class MultiplexProbe extends ProbeSkeleton
{
    private Set<Probe> probes;
    
    MultiplexProbe(Method method, Set<Provider> set) {
        super(method.getParameterTypes());
        this.probes = new HashSet();
        Iterator<Object> iterator = set.iterator();
        while (iterator.hasNext()) {
            Probe probe = ((Provider)iterator.next()).getProbe(method);
            if (probe != null) {
                this.probes.add(probe);
            }
            else {
                continue;
            }
        }
    }
    
    @Override
    public boolean isEnabled() {
        Iterator<Probe> iterator = this.probes.iterator();
        while (iterator.hasNext()) {
            if (((Probe)iterator.next()).isEnabled()) {
                return true;
            }
            continue;
        }
        return false;
    }
    
    @Override
    public void uncheckedTrigger(Object[] args) {
        for (Probe obj : this.probes) {
            try {
                ((ProbeSkeleton)obj).uncheckedTrigger(args);
            }
            catch (ClassCastException ex) {
                try {
                    Probe.class.getMethod("trigger", new Class[] { Class.forName("[java.lang.Object") }).invoke(obj, args);
                }
                catch (Exception ex2) {
                    assert false;
                    continue;
                }
            }
        }
    }
}
